#################################s#o#q######################################

from Products.CMFCore.CMFCorePermissions import AddPortalContent, ManagePortal
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore import utils
from config import *

import DocMgtRoot
import DocMgtFolder
import DocMgtFile
import CMFDocMgtTool
import DocMgtRootPermissions
import DocMgtFolderPermissions
import DocMgtFilePermissions

from ZClasses import createZClassForBase

bases = ( DocMgtRoot.DocMgtRoot, DocMgtFolder.DocMgtFolder, DocMgtFile.DocMgtFile, )

import sys
this_module = sys.modules[ __name__ ]

for base in bases:
    createZClassForBase( base, this_module )

# Make the skins available as DirectoryViews
#registerDirectory( 'skins', globals() )
#registerDirectory( 'skins/soq_docmgt', globals() )
registerDirectory(SKINS_DIR, docmgt_globals)
registerDirectory(SKINS_CONTENT_DIR, docmgt_globals)


tools = (CMFDocMgtTool.CMFDocMgtTool,)

factory_type_information = (
                                DocMgtRoot.factory_type_information 
                                +  DocMgtFolder.factory_type_information 
                                +  DocMgtFile.factory_type_information
                                )
constructors = (
                                DocMgtRoot.addDocMgtRoot
                                ,DocMgtFolder.addDocMgtFolder
                                ,DocMgtFile.addDocMgtFile
                                ,)
contentTypes= (
                                DocMgtRoot.DocMgtRoot
                                ,DocMgtFolder.DocMgtFolder
                                ,DocMgtFile.DocMgtFile
                                ,)

def initialize( context ):

    utils.ToolInit(PROJECTNAME + " Tool", tools=tools,
                   product_name=PROJECTNAME,
                   icon='tool.gif',
                   ).initialize(context)

    ## CMF Initializers
    utils.ContentInit( 'CMFDocMgt'
               , content_types = contentTypes
               , permission = AddPortalContent
               , extra_constructors = constructors
               , fti = factory_type_information
               ).initialize( context )


    #content_types, constructors, ftis = process_types(
    #    listTypes(PROJECTNAME),
    #    PROJECTNAME)
    
    #utils.ContentInit(
    #    PROJECTNAME + ' Content',
    #    content_types      = content_types,
    #    permission         = ADD_CONTENT_PERMISSION,
    #    extra_constructors = constructors,
    #    fti                = ftis,
    #    ).initialize(context)
    
